require 'ucb/hcm/configuration'
require "ucb/hcm/request"
require "ucb/hcm/response"

module Ucb
  module Hcm
    class Api
      include Ucb::Hcm::Request

      # Define the same set of accessors as the Ucb::Hcm::Configuration module
      attr_accessor(*Ucb::Hcm::Configuration::VALID_CONFIG_KEYS)

      def initialize(options={})
        # Merge the config values from the module and those passed
        # to the client.
        merged_options = Ucb::Hcm.options.merge(options)

        # Copy the merged values to this client and ignore those
        # not part of our configuration
        Configuration::VALID_CONFIG_KEYS.each do |key|
          send("#{key}=", merged_options[key])
        end
      end
    end
  end
end
